function _(id)
{
	return document.getElementById(id)
}

function details( what )
{
	var node = _("applist");
	if (node)
	{
		var nodes = node.getElementsByTagName("LI");	
		
		for (var i=0; i<nodes.length; i++)
		{
			node = nodes[i]
			node.className= node.className.replace("sel","");
		}
	}
	
	node = _("list-"+what);
	if (node)
		node.className += " sel";

	var node = _("appdetails");
	if (node)
	{
		var nodes = node.getElementsByTagName("DIV");	
		
		for (var i=0; i<nodes.length; i++)
		{
			node = nodes[i]
			node.className= node.className.replace("sel","");
		}
	}
	
	node = _("detail-"+what);
	if (node)
		node.className += " sel";
}

function show( obj )
{
	if (!obj) return;
	var c = obj.className || "";
	c = c.replace( " hide", "");
	c = c.replace(/^\s+|\s+$/g,"").replace(/\s{2,}/g,' ');
	obj.className = c;
	return  c;
}

function hide( obj )
{
	if (!obj) return;
	var c = obj.className  || ""
	c = c.replace( " hide", "");
	c = c +" hide";
	obj.className = c;
}

var pollTimeOut;

function poll( ms )
{
	var url=window.location.origin + "/html/apps/poll.cgi";
	var objHTTP = new XMLHttpRequest();
	objHTTP.open( "GET", url);
	objHTTP.onreadystatechange = function ()
	{
		if (objHTTP.readyState == 4)
		{
			var s = objHTTP.responseText || "{}";
			var a;
			eval("a="+s); // object of [i]:{name:"name",state:2,mem:34567} 's
			var map = {}

			// put together the states
			for (var i=1; i<1000; i++)
			{
				var o = a[i];
				if (!o) break;
				map[o.name] = (map[o.name] || 0) | 1<<o.state;
			}

			for (var i in AppNames)
			{
				var name=AppNames[i]
				var bits = map[name] || 0;

				if (bits & 0x1E) // >= 1x running or starting or stopping
					hide( _(name+"-run"));
				else
					show( _(name+"-run"));

				if (bits & 0x08) // >= 1x running
					show( _(name+"-stop"));
				else
					hide( _(name+"-stop"));

				if (bits & 0x1E) // >= 1x running or starting or stopping
					hide( _(name+"-remove"));
				else
					show( _(name+"-remove"));
			}
			// see you later...
			clearTimeout( pollTimeOut )
			pollTimeOut = setTimeout( poll, ms || 10000 )
		}
	};
	objHTTP.send( null);
}

function do_poll( ms )
{
	clearTimeout( pollTimeOut )
	pollTimeOut = setTimeout( poll, ms || 10000 )
}

function post( cmd, name )
{
	document.post.cmd.value = cmd+"="+name;
	document.post.submit();

	return false;
}

function send( cmd, name )
{
	var url=window.location.origin + "/html/apps/manager.cgi";
	var s  = "cmd="+cmd+"%3D"+name;
	var objHTTP = new XMLHttpRequest();
	objHTTP.open( "POST", url, false);
	objHTTP.onreadystatechange = function (){if (objHTTP.readyState == 4){do_poll(500)}};
	objHTTP.send( s);
}

function doRemove( name )
{
	if ( confirm( confirm1 ) && confirm( confirm2 ) )
		post( "remove", name);
	else
		post( "nop", "");
}

function doCancel( name )
{
	hide( _(name+"-cancel"));
	hide( _(name+"-install"));
	return post( "cancel", name);
}

function doInstall( name )
{
	hide( _(name+"-cancel"));
	hide( _(name+"-install"));
	return post( "install", name);
}

function doRun( name )
{
	hide( _(name+"-run"));
	hide( _(name+"-remove"));
	send( "run", name);
}

function doStop( name )
{ 
	hide( _(name+"-stop"));
	send( "stop", name);
}
function doLock( name ) 	
{
	send( "lock", name);
	hide( _(name+"-lock"));
	show( _(name+"-unlock"));
}

function doUnlock( name )
{
	send( "unlock", name);
	hide( _(name+"-unlock"));
	show( _(name+"-lock"));
}

window.onload = function(){
	// again... fix IE:
	if (!window.location.origin)
	{
		window.location.origin = window.location.protocol 
		+ "//" + window.location.hostname 
		+ (window.location.port ? ':' + window.location.port : '');
	}

	document.getElementById('uploadfile').onchange = function(e) 
	{
		setTimeout(
			(function(form)
			{
				return function() {form.submit(); }
			})
			(this.form), 10);

	};
	if (MsgBox)
		alert( MsgBox );

	poll( 1000 )
};
